Processing: GRASS commands not escaped correctly

2017-01-23 02:57 AM - Paolo Cavallini

Status: Closed

Priority: High

Assignee: Victor Olaya
Category: Processing/GRASS

Affected QGIS version:2.18.2
Operating System: Debian
Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: No
Easy fix?: No
Resolution: fixed/implemented

Copied to github as #: 24016

Description

A simple GRASS command, e.g.

processing.runalg("grass7:v.clean","’home/paolo/Aree_Elementari.shp",2,0.1,"955403.9934,1054537.9351,4596890.3389,46789

02.6515",-1,0.0001,None,None)

results in:

v.in.ogr min_area=0.0001 snap=-1 input="/home/paolo/" layer=Aree Elementari output=tmp14851690580813 --overwrite -0

instead of:

v.in.ogr min_area=0.0001 snap=-1 input="/home/paolo/" layer="Aree Elementari" output=tmp14851690580813 --overwrite -0

(the space in filename is not escaped) and as a consequence the command fails with:

ERROR: Sorry is not a valid option

History

#1 - 2017-01-23 06:42 AM - Giovanni Manghi

- Status changed from Open to Feedback

If is regression is a severe, not high issue.

Anyway | cannot replicate (2.18.3, grass72), so please add

1) sample data

2) exact steps on how replicate

#2 - 2017-01-23 06:49 AM - Victor Olaya

Giovanni, i guess it will happen when you use any layer with blank spaces in its name as input
Should be easy to fix, i will work on it

#3 - 2017-01-23 07:01 AM - Giovanni Manghi

Victor Olaya wrote:

Giovanni, i guess it will happen when you use any layer with blank spaces in its name as input

Should be easy to fix, i will work on it

Hi Victor,

yes it seems to happen when input layer name has spaces. But the above example does not have spaces in the input file name

processing.runalg("grass7:v.clean","/home/paolo/Aree_Elementari.shp”,2,0.1,"955403.9934,1054537.9351,4596890.3389,4678902.6515",-1,0.0001,No

e,None)

and in another test using an input with underscores this are not replaced by spaces (as the above example would suggest).

#4 - 2017-01-24 12:18 AM - luca barbadoro

- Target version set to Version 2.14

#5 - 2017-01-24 12:19 AM - Paolo Cavallini

| believe Victor has already fixed this.

#6 - 2017-01-24 12:52 AM - Giovanni Manghi

- Resolution set to fixed/implemented
- Status changed from Feedback to Closed

https://github.com/qgis/QGIS/pull/4046/files#diff-0
